/*************************************************************************

   Konfigurationsprogramm fuer  VMEST-Hardwareerweiterungen
   Angelegt: 01.01.88
   Autor   : Ralf Dux
   
 ************************************************************************/
 
#include <gemdefs.h>
#include <osbind.h>
#include <obdefs.h>
#include <stdio.h>

#include "boxtest.h"


#ifndef TRUE
#define TRUE		1
#define FALSE		0
#define NULL		0L
#endif 

#define WORKSIZE	1
#define BORDSIZE	0

#define	MIN(a, b)	((a < b)? a : b)
#define MAX(a, b)	((a > b)? a : b)


typedef struct syszeit
{ 
  unsigned sec : 5;
  unsigned min : 6;
  unsigned std : 5;
} SYSZEIT;

typedef union toszeit
{
  SYSZEIT time;
  int zeitwert;
} TOSZEIT;

 
int contrl[12];
int intin[256],  ptsin[256];
int intout[256], ptsout[256];

OBJECT *menubar;
int			phys_handle;


init_resources()
{
	if (!rsrc_load("boxtest.rsc")) 
	{ form_alert(1, "[0][Cannot find boxtest.rsc | Schweinescheisse ...][KO]");
		exit(2);
	}
}


shutdown(code)
int code;
{
	rsrc_free();
	appl_exit();
	exit(code);
}

int open_vwork(form)
register MFDB	*form;
{
	register int x;
	int 	 work_in[11];
	int		 handle, d;
	int		 work_out[57];

	for(x=0; x<10; x++) work_in[x] = 1;

	work_in[10] = 2;
	handle = graf_handle(&d, &d, &d, &d);
	v_opnvwk(work_in, &handle, work_out);

	form -> fd_addr 	  = Logbase();
	form -> fd_w		    = work_out[0] + 1;
	form -> fd_h		    = work_out[1] + 1;
	form -> fd_wdwidth	= form -> fd_w / 16;
	form -> fd_stand	  = 0;

	switch(work_out[13]) {
		case 16: form -> fd_nplanes = 4; break;
		case 08: form -> fd_nplanes = 3; break;
		case 04: form -> fd_nplanes = 2; break;
		default: form -> fd_nplanes = 1; break;
	}
	return handle;
}

/************************* Dialoghandler *****************************/
testbox()
{
  OBJECT *dialog;
  register int i;
  register TOSZEIT mytime;
	int		x, y, w, h;
  char  anfzeit[80],nezeit[80],zaehler[80];

  /** Adresse holen und Stringadressen eintragen **/
	rsrc_gaddr(0, TESTBOX, &dialog);
	dialog[ANFZEIT].ob_spec = anfzeit;
	dialog[NEZEIT].ob_spec = nezeit;
	dialog[BOXNR].ob_spec = zaehler;

  /** Box zentrieren **/
	form_center(dialog, &x, &y, &w, &h);
	form_dial(FMD_START, 0, 0, 0, 0, x, y, w, h);

  /** Anfangszeit holen und Box 100 * zeichnen **/
  mytime.zeitwert = gemdos(0x2c);
  i=0; sprintf(zaehler,"   Jau, Box Nr. %d",i);
  sprintf(anfzeit,"   Anfzeit: %02d:%02d:%02d",
   	mytime.time.std, mytime.time.min, mytime.time.sec *2);
  for(i=0; i<500; i++)
  {
    /** Jedesmal die Zeit holen **/
    mytime.zeitwert = gemdos(0x2c);
    sprintf(zaehler,"   Jau, Box Nr. %d",i);
    sprintf(nezeit,"   Endzeit: %02d:%02d:%02d",
     	mytime.time.std, mytime.time.min, mytime.time.sec *2);
    objc_draw(dialog, 0, 10, x, y, w, h);
	}

  getchar();

  /** Box Lschen **/
  /*	itemhit = form_do(dialog, 0); */
	form_dial(FMD_FINISH, 0, 0, 0, 0, x, y, w, h);
}


/************************* Initialisierung ****************************/
main()
{
	int  dummy;

	appl_init();
	init_resources();
	phys_handle = graf_handle(&dummy, &dummy, &dummy, &dummy);
	graf_mouse(ARROW, NULL);
  testbox(); 
	shutdown(0);
}

